// Sh: A GPU metaprogramming language.
//
// Copyright (c) 2003 University of Waterloo Computer Graphics Laboratory
// Project administrator: Michael D. McCool
// Authors: Zheng Qin, Stefanus Du Toit, Kevin Moule, Tiberiu S. Popa,
//          Bryan Chan, Michael D. McCool
// 
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
// 
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
// 
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product documentation
// would be appreciated but is not required.
// 
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
// 
// 3. This notice may not be removed or altered from any source
// distribution.
//////////////////////////////////////////////////////////////////////////////
#ifndef SHUTIL_HPP
#define SHUTIL_HPP

#include "ShFunc.hpp"
#include "ShWorley.hpp"
#include "ShWorleyImpl.hpp"
#include "ShNoise.hpp"
#include "ShKernelLib.hpp"
#include "ShKernelLight.hpp"
#include "ShKernelSurfMap.hpp"
#include "ShKernelSurface.hpp"
#include "ShKernelPost.hpp"
#include "ShMesh.hpp"
#include "ShObjMesh.hpp"

/** \namespace ShUtil
 * \brief The main ShUtil namespace.
 *
 * All the extra Sh utility functions and objects reside within this namespace.
 */

/** \file shutil.hpp
 * \brief The include file for extra Sh utilities 
 *
 * You can use this to include all available extra utilities.
 */
namespace ShUtil {
}

#endif
